/* =====================================================================
	hello.cpp - Sample Program for Windows CE by TascalSoft.
===================================================================== */

#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "hatune.h"

/* =====================================================================
	֐̃vg^Cv錾
===================================================================== */
// WinMainĂ΂֐
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);

// R[obN֐
LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);

// _CAO֐
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);

// bZ[W֐
void OnCreate(HWND, WPARAM, LPARAM);
void OnDestroy(HWND, WPARAM, LPARAM);
void OnPaint(HWND, WPARAM, LPARAM);
void OnHelp(HWND, WPARAM, LPARAM);
void mouse_down(HWND, WPARAM, LPARAM);
void timer(HWND);
// t@CEj[֐
void OnFileExit(HWND);			// I

// wvEj[֐
void OnHelpAbout(HWND);			// o[W

/* =====================================================================
	O[oϐ
===================================================================== */
TCHAR gszAppName[]	= TEXT("Hatune");	// NX̖O
TCHAR gszAppTitle[]	= TEXT("Hatune");	// EBhEE^Cg

HINSTANCE ghInst	= NULL;		// ݂̃CX^X
HWND      ghWnd		= NULL;		// CEBhẼnh
HWND      ghWndCB	= NULL;		// R}ho[̃nh

int		winWidth,winHeight;
HDC		baseDC	= NULL;		// ItXN[
HBITMAP	baseBmp	= NULL;
BYTE	*baseBuf;

void put_bmp(int,int,int,int,RECT *);
void clear_bmp(void);

extern int addr[];
extern BYTE bmpdata[];
extern SEQUENCE seq[];

int	hour;
int	sq=0;
int	tm=0,timer_store=-1;

int offset_x=0,offset_y=0;

BOOL	about_flag=FALSE;

#define	MAIN_WIDTH	208
#define	MAIN_HEIGHT	212

/* =====================================================================
	WindowsvÕC֐
===================================================================== */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					 LPTSTR lpszCmdParm, int nCmdShow)
{
	MSG    msg;

	ghInst = hInstance;

	if (!hPrevInstance) {					// ق̃CX^Xs ?
		if (!InitApplication(hInstance))	// ʂ̏
			return FALSE;					// Ɏsꍇ͏I
	}
	if (!InitInstance(hInstance, nCmdShow))	// CX^X̏
		return FALSE;						// sꍇ͏I

	while (GetMessage(&msg, NULL, 0, 0)) {	// bZ[W̎擾ƃfBXpb`
		TranslateMessage(&msg);				// zL[R[h̕ϊ
		DispatchMessage(&msg);				// bZ[W̃fBXpb`
	}
	return msg.wParam;		// PostQuitMessage()֐̖߂lԂ
}

/* =====================================================================
	EBhEENX̓o^
===================================================================== */
BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style		 = 0;					// NXEX^C
	wc.lpfnWndProc	 = MainWndProc;			// EBhEEvV[W
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra	 = 0;
	wc.hInstance	 = hInstance;			// CX^XEnh
	wc.hIcon		 = NULL;
	wc.hCursor		 = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	 = NULL;				// j[̖O
	wc.lpszClassName = gszAppName;			// EBhEENX̖O

	return RegisterClass(&wc);	// EBhEENX̓o^
}

/* =====================================================================
	EBhE̍쐬ƕ\
===================================================================== */
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	ghWnd = CreateWindow(
 		gszAppName,				// o^ꂽEBhEENX̖O
		gszAppTitle,			// ^CgEo[ɕ\eLXg
		WS_VISIBLE,				// EBhEEX^C
		CW_USEDEFAULT,			// EBhE̕\ʒu ()
		CW_USEDEFAULT,			//                      ()
		CW_USEDEFAULT,			// EBhȆ傫   ()
		CW_USEDEFAULT,			//                      ()
		NULL,					// eEBhẼnh
		NULL,					// EBhEENX̃j[gp
		hInstance,				// AvP[VECX^X̃nh
		NULL					// EBhE쐬f[^̃AhX
	);
	if (!ghWnd)
		return FALSE;			// EBhE̍쐬Ɏs

	ShowWindow(ghWnd, nCmdShow);	// EBhE\Ԃ̐ݒ
	UpdateWindow(ghWnd);			// NCAg̈̍XV

	return TRUE;
}

/* =====================================================================
	EBhEEvV[W
===================================================================== */
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMessage,
						 WPARAM wParam, LPARAM lParam)
{
	switch (uMessage) {
	  case WM_TIMER:		timer(hWnd);		break;
	  case WM_CREATE:		OnCreate(hWnd, wParam, lParam);		break;
	  case WM_DESTROY:		OnDestroy(hWnd, wParam, lParam);	break;
	  case WM_PAINT:		OnPaint(hWnd, wParam, lParam);		break;

	  case WM_LBUTTONDOWN:	mouse_down(hWnd,wParam, lParam);	break;

	  default:
		return DefWindowProc(hWnd, uMessage, wParam, lParam);
	}
	return 0;
}

/* =====================================================================
	EBhE쐬̏
===================================================================== */
void OnCreate(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	HDC		hDC;
	RECT	rc;
	static struct {
		BITMAPINFOHEADER	bmih ;
		RGBQUAD	rgq[ 4 ] ;
	} bmi ;
    SYSTEMTIME st;

	// R}ho[̐
//	ghWndCB = CommandBar_Create(ghInst, hWnd, 1);
//	CommandBar_InsertMenubar(ghWndCB, ghInst, IDR_MAIN_MENU, 0);
//	CommandBar_AddAdornments(ghWndCB, CMDBAR_HELP, 0);

	// ACR̐ݒ
	HICON hIcon = (HICON)LoadImage(ghInst, MAKEINTRESOURCE(IDI_MAIN_ICON),
		IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	SendMessage(hWnd, WM_SETICON, FALSE, (WPARAM)hIcon);

	GetWindowRect(hWnd, &rc);
	winWidth  = rc.right - rc.left;
	winHeight = rc.bottom - rc.top - CommandBar_Height(ghWndCB);

	// ItXN[̍쐬
	bmi.bmih.biWidth = winWidth;
	bmi.bmih.biHeight = winHeight ;
	bmi.bmih.biSize = sizeof(bmi.bmih) ;
	bmi.bmih.biPlanes = 1 ;
	bmi.bmih.biBitCount = 2 ;
	bmi.bmih.biCompression = BI_RGB ;
	bmi.bmih.biSizeImage = 0 ;
	bmi.bmih.biXPelsPerMeter = 0 ; 
	bmi.bmih.biYPelsPerMeter = 0 ;
	bmi.bmih.biClrUsed = 0 ;
	bmi.bmih.biClrImportant = 0 ;
	bmi.rgq[0].rgbBlue = bmi.rgq[0].rgbGreen = bmi.rgq[0].rgbRed = 0 ;
	bmi.rgq[1].rgbBlue = bmi.rgq[1].rgbGreen = bmi.rgq[1].rgbRed = 0x80 ;
	bmi.rgq[2].rgbBlue = bmi.rgq[2].rgbGreen = bmi.rgq[2].rgbRed = 0xc0 ;
	bmi.rgq[3].rgbBlue = bmi.rgq[3].rgbGreen = bmi.rgq[3].rgbRed = 255 ;
	
	hDC = GetDC(NULL);
	baseBmp = CreateDIBSection( hDC, (PBITMAPINFO)&bmi.bmih, DIB_RGB_COLORS,
							 (void **)&baseBuf, NULL, 0 ) ;
	if ( !baseBmp ) {
		TCHAR	Message[256];
		wsprintf( Message, TEXT("baseBmp error (%d)"),GetLastError() ) ;
		MessageBox( NULL, Message, TEXT("Error"), MB_OK ) ;
		ReleaseDC( NULL, hDC ) ;
		MessageBeep( MB_ICONASTERISK ) ;
		return  ;
	}
	baseDC = CreateCompatibleDC( hDC ) ;
	if ( !baseDC ) {
		TCHAR	Message[256];
		wsprintf( Message, TEXT("baseDC error (%d)"),GetLastError() ) ;
		MessageBox( NULL, Message, TEXT("Error"), MB_OK ) ;
		DeleteObject( baseBmp);
		ReleaseDC( NULL, hDC ) ;
		MessageBeep( MB_ICONASTERISK ) ;
		return  ;
	}
	SelectObject( baseDC, baseBmp ) ; 

    GetLocalTime(&st);
    hour = st.wHour;

	offset_x=(winWidth-MAIN_WIDTH)/2;
	offset_y=(winHeight-MAIN_HEIGHT)/2;
	
	clear_bmp();

	//	SetTimer(hWnd, 1000,300,NULL);	
	SetTimer(hWnd, 1000,50,NULL);	
}

/* =====================================================================
	EBhEj̏
===================================================================== */
void OnDestroy(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	// R}ho[̔j
//	CommandBar_Destroy(ghWndCB);

	PostQuitMessage(0); 
}

/* =====================================================================
	ʂ̕`
===================================================================== */
void OnPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps; 
	HDC         hDC;

	int		i=winWidth;

	hDC = BeginPaint(hWnd, &ps);
	BitBlt(hDC,offset_x-3,offset_y-3+CommandBar_Height(ghWndCB),MAIN_WIDTH+6,MAIN_HEIGHT+6,
		baseDC,offset_x-3,offset_y-3,SRCCOPY);
/*
	{
		RECT rc;
		TCHAR	s[32];
		GetWindowRect(hWnd, &rc);
		rc.top += CommandBar_Height(ghWndCB);
		wsprintf(s,TEXT("[%d]"),hour);
		DrawText(hDC, s, -1,
			&rc, DT_CENTER | DT_VCENTER);
	}
*/	
	EndPaint(hWnd, &ps);
}
void clear_bmp()
{
	HPEN	hPen;
	HGDIOBJ	hOldPen;
	int i;

	for (i=0;i<winWidth*winHeight/4;i++)
		baseBuf[i]=0xff;

	hPen=CreatePen(PS_SOLID,3,RGB(0,0,0));
	hOldPen=SelectObject(baseDC,hPen);
	RoundRect(baseDC,offset_x-2,offset_y-2,offset_x+MAIN_WIDTH+3,offset_y+MAIN_HEIGHT+3,5,5);
	DeleteObject(SelectObject(baseDC,hOldPen));
}

void put_bmp(int n,int px,int py,int mode,RECT *rc)
{
	int x,y;
	int	w,h,ox,oy;
	int i,k;
	BYTE c;
	BYTE mask1[4]={0xc0,0x30,0x0c,0x03};
	BYTE mask2[4]={0x3f,0xcf,0xf3,0xfc};
	BYTE mask3[8]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

	k=addr[n];
	ox=bmpdata[k++];
	oy=bmpdata[k++];
	w=bmpdata[k++];
	h=bmpdata[k++];

	i=0;
	for (y=0;y<h;y++) {
		for (x=0;x<w;x++) {
			c=(bmpdata[k]&mask3[i]) ? 1:0;
			if (mode!=1 && c==0)
				baseBuf[((winHeight-1-(py+oy+y))*winWidth+(px+ox+x))/4]|=mask1[(px+ox+x)%4];
			if (mode!=2 && c==1)
				baseBuf[((winHeight-1-(py+oy+y))*winWidth+(px+ox+x))/4]&=mask2[(px+ox+x)%4];
			i++;
			if (i==8) {
				i=0;
				k++;
			}
		}
	}
	if (rc->left  >px+ox) rc->left  =px+ox;
	if (rc->top   >py+oy) rc->top   =py+oy;
	if (rc->right <px+ox+w) rc->right =px+ox+w;
	if (rc->bottom<py+oy+h) rc->bottom=py+oy+h;
}

void timer(HWND hWnd)
{
	int	ox,oy;
	int t;
	RECT	rc;
	
	if (about_flag==TRUE) return;
	
	tm+=50;
	if (timer_store>tm) return;
	tm=0;

	ox=offset_x;
	oy=offset_y;
	
	rc.left=rc.top=999;
	rc.right=rc.bottom=-1;

	for (;;) {
		t=seq[sq].wait;
		if (t<0) {
			SendMessage(hWnd, WM_DESTROY, FALSE, FALSE);
			return;
		}

		if (seq[sq].func==0) {
			put_bmp(seq[sq].pat0,ox,oy,seq[sq].mode,&rc);			
		}
		if (seq[sq].func==1) {
			put_bmp(seq[sq].pat0,ox+FX,oy+FY,seq[sq].mode,&rc);			
		}
		if (seq[sq].func==2) {
			int	tenki,p;
			static int tenki_pattern[]={0,1,0,1,0,1,0,2,0,2,3,0};
			tenki=tenki_pattern[GetTickCount()%11];
			if (tenki==0) p=seq[sq].pat0;
			if (tenki==1) p=seq[sq].pat1;
			if (tenki==2) p=seq[sq].pat2;
			if (tenki==3) p=seq[sq].pat3;
			put_bmp(p,ox+FX,oy+FY,seq[sq].mode,&rc);			
		}
		if (seq[sq].func==3) {
			int	p;
			if (hour<4 || 16<hour)	p=seq[sq].pat1;
			else					p=seq[sq].pat0;
			put_bmp(p,ox+FX,oy+FY,seq[sq].mode,&rc);			
		}
		if (seq[sq].func==4) {
			int	p;
			if (hour<4 || 9<hour)	p=seq[sq].pat1;
			else					p=seq[sq].pat0;
			put_bmp(p,ox+FX,oy+FY,seq[sq].mode,&rc);			
		}
		if (seq[sq].func==5) {
		}
		if (seq[sq].func==6) {
		}
		sq++;
		if (t!=0) break;
	}
	InvalidateRect(hWnd,&rc,FALSE);
	timer_store=t;
}

void mouse_down(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if (about_flag==TRUE) {
		clear_bmp();
		sq=0;
		tm=0;
		timer_store=-1;
		about_flag=FALSE;
	} else {
		RECT rc;
		about_flag=TRUE;
		clear_bmp();
		put_bmp(B_INFO,offset_x+3,offset_y+3,0,&rc);
		rc.left=offset_x-3;
		rc.top=offset_y-3;
		rc.right=offset_x+MAIN_WIDTH+6;
		rc.bottom=offset_y+MAIN_HEIGHT+6;
		InvalidateRect(hWnd,&rc,FALSE);
	}
}
